package com.github.marwin1991.keep_changelog.yaml.model;

import com.github.marwin1991.keep_changelog.yaml.converter.ChangeLogEntryTypeConverter;
import de.beosign.snakeyamlanno.property.YamlProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ChangelogEntry {

    private String title;
    private List<Author> authors;
    private String mergeRequest;
    private List<String> issues;
    private List<ChangelogLink> links;
    private ChangeLogEntryType type;
    private List<String> recommendations;
    private List<Configuration> configuration;

    @YamlProperty(key = "merge_request")
    public void setMergeRequest(String mergeRequest) {
        this.mergeRequest = mergeRequest;
    }

    @YamlProperty(key = "type", converter = ChangeLogEntryTypeConverter.class)
    public void setType(ChangeLogEntryType type) {
        this.type = type;
    }

}
